<?php
// Hochladen von Backup files, die Datenbank wird angepasst.

include('/usr/local/php/include/confBackup.Class.php');
include('../misc/database.php');
include('../includes/variables.php');
require_once('../includes/Helper/Helper.php');
require_once('/usr/local/www/berogui/includes/session.php');
include_once ('/usr/local/php/include/restore.Class.php');
// Do the new thing.
include('/usr/php/include/configExportImportTool.class.php');


$fileName = $_FILES['uploadfile']['name'];
$tempFile = $_FILES['uploadfile']['tmp_name'];

if (strstr($fileName, '.config.xml')) {
	$imp = new configExportImportTool($tempFile);
	//get file list of the config
	if ($_GET['getFiles'] == "true") {
		echo rootHelper::jsonEncode(array_merge($imp->getFileGroups(),array("appConfig"=>$imp->getAppInfo())));
		exit(0);
	}
	//normal behaviour
	else {
		//import config files
		$appConfigFiles = $imp->fileGroupsToFiles($appConfigFiles);
		$answ = $imp->importConfigFiles($_POST['configFiles']);
		if ($answ===false) {
			echo '<script>alert(\'Failed!!\')</script><script>window.location=\'../index.php?m=BackupRestore\';</script>';
			exit(0);
		}

		// go over appConfigFiles
	if (($appConfigFiles = $imp->getAppConfigFiles()) !== false) {
		foreach ($appConfigFiles as $app) {
			@mkdir('/usr/conf/userapp/' . $app['name']);

			if (empty($app['files'])) {
				continue;
			}

			foreach ($app['files'] as $appFile) {
				switch ($appFile['mode']) {
				case 'directory':	system('/bin/mkdir -p /usr/conf/userapp/' . $appFile['name']);	break;
				case 'binary':		$fileData = base64_decode($appFile['content']);			break;
				default:		$fileData = $appFile['content'];				break;
				}

				if ($appFile['mode'] != 'directory') {
					@unlink('/usr/conf/userapp/' . $appFile['name']);
					$FP = fopen('/usr/conf/userapp/' . $appFile['name'], 'w');
					fwrite($FP, $fileData, strlen($fileData));
					fclose($FP);
					$FP = null;
					unset($fileData);
				}

				system('/bin/chown admin:admin /usr/conf/userapp/' . $appFile['name']);
			}
		}
		}

		$restore=new restoreConfig(0);

		if (!$restore->restoreConfig()){
			echo str_replace(array("\r\n", "\n", "\r"), '<br />', $restore->getLog());
			exit(1);
		}
		Helper::activate(3);
		echo '<script>window.location=\'../index.php?m=BackupRestore\';</script>';
		exit(0);
	}
} else if (strstr($fileName, '.xml')) {
	echo "<script>alert('Please update a \'.config.xml\' file generated by a beroNet device.'); window.location='../index.php?m=BackupRestore';</script>";
	exit(0);
}

// Do the old thing
$cb = new confBackup();

switch ($cb->verifyFileName($fileName)) {
case 0:			// invalid filename
	$js_txt =	'The uploaded file \'' . $fileName . '\' is not a valid configuration-backup!';
	echo "<script>alert(\"" . $js_txt . "\"); window.location='../index.php?m=BackupRestore';</script>";
	exit(0);
case 1:			// single conf-file
	if ($cb->installConfFile($fileName, $tempFile) == false) {
	     	echo '<script>alert(\'Failed!!\')</script>';
	}

	break;
case 2:			// tar.gz with different name
	$js_txt =	'The uploaded file \'' . $fileName . '\' seems not to be a backup of the configuration of this beroNet Gateway.' . "\n" .
			'Are you sure you want to proceed to restore this backup file?';
	echo 	'<script type="text/javascript">' . "\n" .
		'if (confirm(\'' . $js_txt . '\') == false) {' . "\n" .
		'window.location=\'../index.php?m=BackupRestore\';' . "\n" .
		'}' . "\n" .
		'</script>' . "\n";
case 3:			// tar.gz with fitting name
	if ($cb->installFullBackup($fileName, $tempFile) == false) {
		echo '<script>alert(\'Failed!!\')</script>';
	}
	break;
}

$cb->installCleanup();
@unlink('/tmp/' . $fileName);

Helper::activate(3);
echo '<script>window.location=\'../index.php?m=BackupRestore\';</script>';

?>